import random
import curses
import os

def settings():
    lang = {'eng':[0,1], 'ru':[1,0], }
    language = 'ru'    # настройка языка - либо eng, либо ru
    count_questions = 3 # стартовое число вопросов, минимум - 3
    variants = 3        # число вариантов ответа на один вопрос, минимум - 3
    time_for_answer = 3 # время для ответа на один вопрос, в секундах, минимум - 1
    return lang, language, variants, count_questions, time_for_answer

def get_from_file(dictionary):
    lines = None
    _dict = dictionary[1]
    with open(_dict) as f:
        lines = f.readlines()
    
    words = []
    for line in lines:
        word = []
        _words = line.split(';')
        for w in _words:
            word.append(w.strip())
        if len(word) == 2:
            words.append(word)    

    return words

# рандомная инициализация данных
def get_words(words, variants, count_questions, read_from_file, dictionary, clicks = None, select=False):
    if read_from_file is True:
        _words = get_from_file(dictionary)
        if select is True:
            return _words, None, None, None
        if clicks:
            words = []
            count = 0
            for word in _words:
                if clicks[count] == 1:
                    words.append(word)
                count += 1
            count_questions = len(words)
        else:    
            if count_questions == 0:
                words = _words
            else:    
                words = _words[:count_questions]

    count = 0
    check_answers = []
    words_index = []
    words_rnd = []

    while True:
        rnd = random.randint(0, count_questions-1)
        if rnd not in words_index:
            words_index.append(rnd)
        if len(words_index) == count_questions:
            break

    for i in words_index:
        check_answers.append(0)
        _rnd = []
        while True:
            rnd = random.randint(0, count_questions-1)
            if rnd not in _rnd:
                _rnd.append(rnd)
            if len(_rnd) == variants:
                if i not in _rnd:
                    _rnd = []
                else:    
                    words_rnd.append(_rnd)
                    break

    return words, words_index, words_rnd, check_answers

# добавление 
def add_word(words, count_questions, dictionary):
    _words = get_from_file(dictionary)
    add_word = []
    for _word in _words:
        if _word not in words:
            words.append(_word)
            add_word = _word
            count_questions += 1
            break
    return words, count_questions, add_word

def change_language(language):
    if language == 'ru':
        return 'eng'
    return 'ru'    

def print_answers(words, index, rnd, check_answers, answerbox, right_answers):
    answerbox.clear()
    answerbox.box()
    count = 0
    count_error = 0
    for i in index:
        if check_answers[count] == 0:
            if 3 + count_error < 30:
                answerbox.addstr(3 + count_error, 1, str(words[index[count]]))
            count_error += 1
        count += 1    
    for i in index:
        check_answers.append(0)
    if count_error > 0:
        answerbox.addstr(1,1, " Ответы : " + str(right_answers) + ' из ' + str(len(words)))
        answerbox.addstr(2,1, " Ошибки в словах : ")
    else:
        answerbox.addstr(1,1, " Ошибок нет ! ")
        answerbox.addstr(2,1, " Все ответы правильные : " + str(right_answers) + ' из ' + str(len(words)))
        count = 0    
        count_error = 0
        for i in index:
            if check_answers[count] == 1:
                if 3 + count_error < 30:
                    answerbox.addstr(3 + count_error, 1, str(words[index[count]]))
                count_error += 1
            count += 1    
    check_answers = []

    answerbox.refresh()
    return check_answers


# проверяем ответ для текущей строки, перерисовываем экран вариантов ответа
def next_word(word_index, words, index, rnd,  position, answerbox, right_answers, resultbox, stdscr, 
    check_answers, variants, count_questions, questionbox, language, time_for_answer, dictionary, selectbox, lang):
    _time2 = 0

    answerbox.clear()
    answerbox.box()

    count = 0
    ii = 0
    rnd_count = []
    _found = 0
    for i in index:
        if count == word_index:
            ii = i
            if i == rnd[count][position]:
                right_answers += 1
                check_answers[count] = 1
                _found = 1
        count += 1    

    position = 0    
    word_index += 1

    #################################### итог ########################################### 
    if word_index == len(words):
        word_index = 0
        check_answers = print_answers(words, index, rnd, check_answers, answerbox, right_answers)

        resultbox.clear()
        resultbox.box()
        resultbox.refresh()
        resultbox.addstr(1,3, " Начать тест - (%s  %s из %s) - нажмите пробел" % (dictionary[0], len(words), dictionary[2]))
        resultbox.addstr(2,3, " Добавить новое слово - клавиша + . Произвольный выбор слов - клавиша /")
        resultbox.addstr(3,3, " Сменить язык - клавиша *")
        resultbox.addstr(4,3, " Время на ответ в секундах - " + str(time_for_answer) + ". Увеличить время - стрелка вверх. Уменьшить время - стрелка вниз.")

        questionbox.clear()
        questionbox.box()
        questionbox.refresh()

        _select = 0
        words_add = []
        while True:
            next_key = resultbox.getch()
            key = key if next_key == -1 else next_key
            if key == ord(' '): # пробел - старт
                break
            if key == 43: # клавиша + добавить слово 
                words, count_questions, _add_word = add_word(words, count_questions, dictionary)
                words_add.append(_add_word)
                answerbox.clear()
                answerbox.box()
                answerbox.addstr(1,1, " Добавлено: ")
                count = 0    
                for word in words_add:
                    if count > 27:
                        break
                    answerbox.addstr(2 + count, 1, str(word))
                    count +=1
            if key == 47: # клавиша /  произвольный выбор слов
                words, index, rnd, check_answers  = select(words, selectbox, stdscr, dictionary, count_questions, variants)
                count_questions = len(words)
                _select = 1
                break
            if key == ord('*'): # сменить язык
                language = change_language(language)
                answerbox.clear()
                answerbox.box()
                answerbox.addstr(1,1, " Перевод: ")
                if language == 'eng':
                    answerbox.addstr(2 , 1, str('С английского на русский'))
                else:
                    answerbox.addstr(2 , 1, str('С русского на английский'))
            if key == 65: # стрелка вверх
                time_for_answer += 1               
                resultbox.addstr(4,3, " Время на ответ в секундах - " + str(time_for_answer) + ". Увеличить время - стрелка вверх. Уменьшить время - стрелка вниз.")
            if key == 66: # стрелка вниз
                if time_for_answer > 1:
                    time_for_answer -= 1
                    resultbox.addstr(4,3, " Время на ответ в секундах - " + str(time_for_answer) + ". Увеличить время - стрелка вверх. Уменьшить время - стрелка вниз.")
            answerbox.refresh()                    

        resultbox.clear()
        resultbox.box()
        resultbox.refresh()
        questionbox.clear()
        questionbox.box()
        questionbox.refresh()
        answerbox.clear()
        answerbox.box()
        answerbox.refresh()
        right_answers = 0
        if _select == 0:
            words, index, rnd, check_answers = get_words(words, variants, count_questions, False, dictionary)
    return _time2, word_index, position, right_answers, check_answers, words, index, rnd, count_questions, language, time_for_answer


# перерисовываем курсор
def redraw_cursor(words, index, rnd, position, word_index, answerbox, questionbox, lang, language, resultbox):
    questionbox.addstr(1,3, '                                                                                             ')
    questionbox.addstr(1,3, words[index[word_index]][lang[language][0]])
    resultbox.addstr(3,3, '                                                            ')
    resultbox.addstr(3,3, " Выход - клавиша ESC")

    _count = 0    
    for i in index:
        if _count == word_index:
            count = 0
            mode = curses.A_NORMAL
            for j in rnd[_count]:
                if count == position:
                    #mode = curses.A_REVERSE
                    msg = "[+] %s" % (words[j][lang[language][1]])
                else:
                    msg = "[ ] %s" % (words[j][lang[language][1]])
                    #mode = curses.A_NORMAL
                #msg = "%s" % (words[j][lang[language][1]])
                answerbox.addstr(1 + count, 1, msg, mode)
                count += 1
        _count += 1    

def get_key(answerbox, position, key, word_index, words, index, rnd, right_answers, resultbox, stdscr, variants, check_answers):

    ok = 0
    next_key = answerbox.getch()
    key = key if next_key == -1 else next_key

    if key == curses.KEY_DOWN:
        position += 1
        if position == variants:
            position = 0
    if key == ord(' '):
        position += 1
        if position == variants:
            position = 0
    if key == curses.KEY_UP:
        position -= 1
        if position < 0:
            position = variants - 1
    if key == curses.KEY_LEFT:
        pass
    if key == curses.KEY_RIGHT:
        pass
    if key in [curses.KEY_ENTER, ord("\n")]:
        ok = 1
    if key == 27: # выход - esc
        curses.endwin()
        quit()

    return key, position, ok    


def select(words, selectbox, stdscr, dictionary, count_questions, variants):
    words, index, rnd, check_answers = get_words([], variants, count_questions, True, dictionary, None, True)
    selectbox.clear()
    selectbox.box()
    position = 0
    selectbox.keypad(1)

    lines, cols = stdscr.getmaxyx()
    key = curses.KEY_DOWN 
    clicks = []
    for i in range(0,len(words)):
        clicks.append(0)

    shift = 0
    while True:
        selectbox.clear()
        selectbox.box()
        for i in range(0,lines-2):
            if i == position:
                mode = curses.A_REVERSE
            else:
                mode = curses.A_NORMAL
            if clicks[i+shift] == 0:    
                msg = "[ ] %s" % (str(words[i+shift]))
            else:    
                msg = "[x] %s" % (str(words[i+shift]))
            selectbox.addstr(1 + i, 1, msg, mode)

        selectbox.addstr(0, 10, "Выбрать слово(не менее трех) - клавиша пробел, начать тест - клавиша Enter")
        selectbox.refresh()

        next_key = selectbox.getch()
        key = key if next_key == -1 else next_key
        if key == curses.KEY_DOWN:
            if position != lines-3:
                position += 1
            else:
                shift += 1
        if key == curses.KEY_UP:
            if position != 0:
                position -= 1
            else:
                if shift > 0:
                    shift -= 1    
        if key == ord(' '):
            if clicks[position+shift] == 0:
                clicks[position+shift] = 1
            else:
                clicks[position+shift] = 0
            if position < lines-3:
                position += 1
        if key in [curses.KEY_ENTER, ord("\n")]:
            count = 0
            for c in clicks:
                if c == 1:
                    count += 1
            if count > 2:        
                curses.endwin()
                break

    selectbox.clear()
    selectbox.box()
    selectbox.refresh()

    words, index, rnd, check_answers  = get_words([], variants, count_questions, True, dictionary, clicks, False)   
    return words , index, rnd, check_answers 
    

def start(selectbox):

    dicts = [['Общий словарь', 'words.txt', 1],
             ['Мир', 'world.txt', 1],
             ['Человек', 'human.txt', 1],
             ['Дом', 'house.txt', 1],
             ['Образование', 'education.txt', 1],
             ['Информация', 'information.txt', 1],
             ['Наука', 'science.txt', 1],
             ['Транспорт', 'transport.txt', 1],
             ['Идиомы', 'idiom.txt', 1],
             ['Экономика', 'economy.txt', 1]]

    _dicts = dict()
    for root, dirs, files in os.walk("."):  
        for file in files:
            if '.txt' in file:
                _len = 0
                with open(file) as f:
                    _len = len(f.readlines())
                if _len > 0:    
                    _dicts[file] = _len    
    for d in dicts:
        if d[1] in _dicts:
            print(d[1], _dicts[d[1]])
            d[2] = _dicts[d[1]]

    selectbox.clear()
    selectbox.box()
    position = 0
    selectbox.keypad(1)

    selectbox.addstr(1, 10, "Выберите словарь  (выбор - клавиша Enter, выход - клавиша ESC)")
    key = curses.KEY_DOWN 
    clicks = []
    for i in range(0, len(dicts)):
        clicks.append(0)

    click_dic = 'words.txt'    
    while True:
        for i in range(0, len(dicts)):
            if i == position:
                mode = curses.A_REVERSE
            else:
                mode = curses.A_NORMAL
            if clicks[i] == 0:    
                msg = " %s (%s)" % (str(dicts[i][0]), str(dicts[i][2]))
            else:    
                msg = " %s (%s)" % (str(dicts[i][0]), str(dicts[i][2]))
            selectbox.addstr(3 + i, 1, msg, mode)
        
        selectbox.refresh()

        next_key = selectbox.getch()
        key = key if next_key == -1 else next_key
        if key == curses.KEY_DOWN:
            if position < len(dicts) - 1:
                position += 1
        if key == curses.KEY_UP:
            if position != 0:
                position -= 1
        if key == ord(' '):
            if clicks[position] == 0:
                clicks[position] = 1
            else:
                clicks[position] = 0
            if position < len(dicts):
                position += 1
        if key in [curses.KEY_ENTER, ord("\n")]:
            click_dic = dicts[position]
            curses.endwin()
            break
        if key == 27: # выход - esc
            curses.endwin()
            quit()
    
    selectbox.clear()
    selectbox.refresh()
    return click_dic


def main():

    stdscr = curses.initscr()
    curses.start_color()
    lines, cols = stdscr.getmaxyx()

    curses.noecho()    # не печатать на экране
    curses.cbreak()    # не ждать ввода
    curses.curs_set(0) # не показывать курсор

    questionbox = curses.newwin(3,100,6,1) # высота окна, ширина окна, y-координата, x-координата
    questionbox.box()

    resultbox = curses.newwin(6,100,0,1)
    resultbox.box()

    answerbox = curses.newwin(30, 100, 9, 1)
    answerbox.box()
    answerbox.keypad(1)
    answerbox.timeout(100) # секунда состоит из 10 тиков по 100 миллисекунд

    selectbox = curses.newwin(lines, cols,0,0)
    selectbox.box()

    dictionary = start(selectbox)

    lang, language, variants, count_questions, time_for_answer = settings()
    words, index, rnd, check_answers = get_words([], variants, count_questions, True, dictionary)

    _time1 = 0 
    _time2 = 0 
    word_index = 0
    position = 0
    right_answers = 0

    resultbox.addstr(1,3, " Список из " + str(count_questions) + ' слов, ' + ' вариантов перевода - ' + str(variants))
    resultbox.addstr(2,3, " Время на ответ в секундах - " + str(time_for_answer))
    resultbox.addstr(3,3, " Начать тест - (%s  %s) - нажмите любую клавишу" % (dictionary[0], dictionary[2]))
    resultbox.getch()

    key = curses.KEY_RIGHT 

    while True:
        resultbox.refresh()
        questionbox.refresh()
        key, position, ok = get_key(answerbox, position, key, word_index, words, index,
            rnd, right_answers, resultbox, stdscr, variants, check_answers)
        if ok != 1:
            _time1 += 1
            if _time1 == 10:
                _time1 = 0
                _time2 += 1    
        if _time2 == time_for_answer or ok == 1:
            _time2, word_index, position, right_answers, check_answers, words, index, rnd, count_questions, language, time_for_answer= \
            next_word(word_index, words, index, rnd, position, answerbox, right_answers, resultbox, stdscr, \
                check_answers, variants, count_questions, questionbox, language, time_for_answer, dictionary, selectbox, lang)
        redraw_cursor(words, index, rnd, position, word_index, answerbox, questionbox, lang, language, resultbox)
        key = 0

main()
